:: build_bin.bat <test>
::	compile & build UDM source files
:: 
:: Arguments:
::	<Test>: optional argument, if specified udm regression tests will be compiled and executed
::	
:: Requirements:
::	1. vcvars32.bat and MSDEV.exe must be in PATH
::	2. Environment variable CINTSYSDIR must be set to the CINT folder
::	3. Environment variable UDM_PATH must be set to the local UDM root folder
::	4. Environment variable UDM_3RDPARTY must be set to the local UDM 3rdParty folder
::	5. Environment variable GREAT_PATH must be set to the local GReAT root folder

	SET ERRORLEV=0
	call vcvars32.bat
	set PATH=%PATH%;%UDM_PATH%\bin;%CINTSYSDIR%;%UDM_3RDPARTY%\sed;%UDM_3RDPARTY%\INFO-ZIP;%UDM_3RDPARTY%\cppunit-1.10.2\bin
	set INCLUDE=%UDM_3RDPARTY%\STL;%UDM_3RDPARTY%\XERCES\XERCES-C_2_5_0-WINDOWS_NT-MSVC_60\INCLUDE;%UDM_3RDPARTY%\XERCES\XERCES-C_2_5_0-WINDOWS_NT-MSVC_60\INCLUDE\XERCESC;%UDM_3RDPARTY%\XALAN\XALAN-C_1_8_0-WINDOWS_2000-MSVC_60\INCLUDE;%UDM_3RDPARTY%\XALAN\XALAN-C_1_8_0-WINDOWS_2000-MSVC_60\INCLUDE\XALANC;%UDM_3RDPARTY%\ANTLR\ANTLR-2.7.1\LIB\CPP;%UDM_3RDPARTY%\OCL\INCLUDE;%UDM_3RDPARTY%\ZLIB;%UDM_3RDPARTY%\CINT;%UDM_3RDPARTY%\ZLIB\CONTRIB\MINIZIP;%INCLUDE%
	set LIB=%UDM_3RDPARTY%\XERCES\XERCES-C_2_5_0-WINDOWS_NT-MSVC_60\LIB;%UDM_3RDPARTY%\XALAN\XALAN-C_1_8_0-WINDOWS_2000-MSVC_60\LIB;%UDM_3RDPARTY%\ZLIB\;%UDM_3RDPARTY%\CINT;%UDM_3RDPARTY%\OCL\LIB;%UDM_3RDPARTY%\ANTLR\ANTLR-2.7.1\LIB;%LIB%
	set CLASSPATH=%UDM_3RDPARTY%\ANTLR\ANTLR-2.7.1
	cd /d %UDM_PATH%

	MSDEV Udm.dsw /MAKE "UdmAll - Win32 Release" /REBUILD /USEENV >>  %UDM_LOGF%	
	IF ERRORLEVEL 1 SET ERRORLEV=1
	MSDEV Udm.dsw /MAKE "UdmAll - Win32 Debug" /REBUILD /USEENV >>  %UDM_LOGF%	
	IF ERRORLEVEL 1 SET ERRORLEV=1
:: No rebuild version:
::	MSDEV Udm.dsw /MAKE "UdmAll - Win32 Release" /USEENV /OUT >>  %UDM_LOGF%	
::	MSDEV Udm.dsw /MAKE "UdmAll - Win32 Debug" /USEENV /OUT >>  %UDM_LOGF%		

:: No longer necessary
::cd /d %GREAT_PATH%\Libraries\MetaGMEAPI\
::	MSDEV MetaGMEAPI.dsp /MAKE "MetaGMEAPI - Win32 Debug" /REBUILD /USEENV >>  %UDM_LOGF%	
::	IF ERRORLEVEL 1 SET ERRORLEV=1
::	MSDEV MetaGMEAPI.dsp /MAKE "MetaGMEAPI - Win32 Release" /REBUILD /USEENV >>  %UDM_LOGF%	
::	IF ERRORLEVEL 1 SET ERRORLEV=1

:: No longer necessary
::cd /d %GREAT_PATH%\Libraries\UmlGMEAPI\
::	MSDEV UmlGMEAPI.dsp /MAKE "UmlGMEAPI - Win32 Debug" /REBUILD /USEENV >>  %UDM_LOGF%	
::	IF ERRORLEVEL 1 SET ERRORLEV=1
::	MSDEV UmlGMEAPI.dsp /MAKE "UmlGMEAPI - Win32 Release" /REBUILD /USEENV >>  %UDM_LOGF%	
::	IF ERRORLEVEL 1 SET ERRORLEV=1

cd /d %GREAT_PATH%\Tools\MetaGME2UMX\
	MSDEV MetaGME2UML.dsp /MAKE "MetaGME2UML - Win32 Debug" /REBUILD /USEENV >>  %UDM_LOGF%	
	IF ERRORLEVEL 1 SET ERRORLEV=1
	MSDEV MetaGME2UML.dsp /MAKE "MetaGME2UML - Win32 Release" /REBUILD /USEENV >>  %UDM_LOGF%	
	IF ERRORLEVEL 1 SET ERRORLEV=1

cd /d %GREAT_PATH%\Tools\MetaGME2UMX\MetaGME2UMX Interpreters\
	MSDEV MetaGME2UML_interpreter.dsp /MAKE "MetaGME2UML Interpreters - Win32 Debug" /REBUILD /USEENV >>  %UDM_LOGF%	
	IF ERRORLEVEL 1 SET ERRORLEV=1
	MSDEV MetaGME2UML_interpreter.dsp /MAKE "MetaGME2UML Interpreters - Win32 Release" /REBUILD /USEENV >>  %UDM_LOGF%	
	IF ERRORLEVEL 1 SET ERRORLEV=1

if NOT "%1" == "test" GOTO SkipTests
	set PATH=%PATH%;%UDM_3RDPARTY_BIN%\bin
	set INCLUDE= %UDM_3RDPARTY%\cppunit-1.10.2\include\;%INCLUDE%
	set LIB= %UDM_3RDPARTY%\cppunit-1.10.2\lib;%LIB%
	regsvr32.exe /s "%UDM_PATH%\bin\uml2xml.dll"
	cd /d %UDM_PATH%\tests
	MSDEV UdmTests.dsw /MAKE "UdmTestsAll - Win32 Release" /REBUILD /USEENV >>  %UDM_LOGF%	
	IF ERRORLEVEL 1 SET ERRORLEV=1
:SkipTests
