#include <string>
#include <Uml.h>
#include <fstream>
#include <UmlExt.h>


/*
	02/15/05	-	Himanshu
		Fixed the association error.
	02/14/05	-	endre
	
	  Fixed g++ 3.0 compiler issue
	
	UdmJava.cpp: In function `void GenerateFactory(const Uml::Diagram&)':
	UdmJava.cpp:562: error: name lookup of `r_i' changed for new ISO `for' scoping
	UdmJava.cpp:546: error:   using obsolete binding at `r_i'
	UdmJava.cpp:586: error: name lookup of `classes_i' changed for new ISO `for' scoping
	UdmJava.cpp:535: error:   using obsolete binding at `classes_i'

*/

string GetTime();
string tolower(const string& str)
{
	string ret;
	for (unsigned int i = 0; i < str.size(); i++)
	{
		ret += tolower(str[i]);
	}
	return ret;
};

string GetCCRString(const Uml::CompositionChildRole& ccr)
{
	return ((string)ccr.name()) +  "_ccr";
};

Uml::Class GetFirstNonAbstractAncestor(const Uml::Class &cl)
{
	set<Uml::Class> ancs= cl.baseTypes();
	if (ancs.size())
	{
		Uml::Class anc = *(ancs.begin());
		Uml::Class ret = GetFirstNonAbstractAncestor(anc);
		if (ret) return ret;
		if (cl.isAbstract()) return NULL;
		return cl;
	}
	if (cl.isAbstract()) return NULL;
	return cl;

};


void GenerateJavaClassFactory(const Uml::Class &cl, ofstream &output)
{
	string name = cl.name();
	if (cl.isAbstract()) return; 

	Uml::Class ret_type = GetFirstNonAbstractAncestor(cl);
	string ret_type_name = ret_type.name();

	set<Uml::Class> conts = Uml::AncestorContainerClasses(cl);
	for (set<Uml::Class>::iterator c_i = conts.begin();c_i != conts.end(); c_i++)
	{
		string c_i_name = c_i->name();
		Uml::Composition comp = Uml::matchChildToParent(cl, *c_i);
		
			
		if (comp)
		{
			//without childroles
			output << "\tpublic static " << ret_type_name << " create(" << c_i_name << " parent) throws UdmException " << endl;
			output << "\t{" << endl;
				output << "\t\tDiagram metaDiagram = parent.getDiagram();" << endl;
				output << "\t\treturn new " << name << "(parent.createObject(META_TYPE), metaDiagram);" << endl;
			output << "\t}" << endl;

		}
		else
		{
			//with childroles
			set<Uml::CompositionChildRole> ccrs = Uml::CompositionPeerChildRoles(*c_i);
			for (set<Uml::CompositionChildRole>::iterator ccrs_i = ccrs.begin(); ccrs_i != ccrs.end(); ccrs_i++)
			{
				Uml::Class parent = Uml::theOther(*ccrs_i).target();
				Uml::Class child = ccrs_i->target();
				string child_name = child.name();
				Uml::Composition comp = Uml::matchChildToParent(child, parent);
				if (!comp)
				{
					//will reach here only if more than one composition is possible
					output << "\tpublic static " << ret_type_name << " create" << (string)(ccrs_i->name()) <<  "(" << c_i_name << " parent) throws UdmException " << endl;
					output << "\t{" << endl;
					output << "\t\tDiagram metaDiagram = parent.getDiagram();" << endl;
					output << "\t\treturn new " << name << "(parent.createObject(META_TYPE, \""<< (string)(ccrs_i->name()) << "\"), metaDiagram);" << endl;
					output << "\t}" << endl;

				}
			}
		}
	}
};

void GenerateJavaClassContainments(const Uml::Class &cl, ofstream & output)
{
	set<Uml::Class> conts = Uml::ContainedClasses(cl);
	for (set<Uml::Class>::iterator c_i = conts.begin();c_i != conts.end(); c_i++)
	{
		set<Uml::Class> conts_der = Uml::DescendantClasses(*c_i);
		for(set<Uml::Class>::iterator c_d_i = conts_der.begin(); c_d_i != conts_der.end() ; c_d_i++)
		{
			if (c_d_i->isAbstract()) continue;
			Uml::Composition comp = Uml::matchChildToParent(*c_d_i, cl);
			string c_i_name = c_d_i->name();
				
			if (comp)
			{
				//only one composition
				//createXXX
				/*
				output << "\tpublic " << c_i_name << " create" << c_i_name << "() throws UdmException" << endl;
				output << "\t{" << endl;
					output << "\t\t" << c_i_name <<".initMetaClass(metaDiagram);" << endl;
					output << "\t\treturn new " << c_i_name << "(createObject(" << c_i_name << ".META_TYPE), metaDiagram);" << endl;
				output << "\t}" << endl;
				*/
				//getXXXChildren
				Uml::CompositionChildRole ccr = comp.childRole();
				string ccr_name = ccr.name();
				
				if ((ccr.max() == -1) || (ccr.max() > 1))
				{
					

					output << "\tpublic " << c_i_name <<"[] get" << c_i_name << "Children() throws UdmException "<< endl;
					output << "\t{" << endl;
					if(strcmp(ccr_name.c_str(), "") == 0) {
						output << "\t\tUdmPseudoObjectContainer container = getChildren(null, " << c_i_name << ".META_TYPE);" << endl;
					} else {
						output << "\t\tUdmPseudoObjectContainer container = getChildren(\""<< ccr_name << "\", " << c_i_name << ".META_TYPE);" << endl;
					}
						output << "\t\t" << c_i_name <<"[] res = new " << c_i_name << "[container.getLength()];" << endl;
						output << "\t\tfor(int i=0; i<container.getLength(); i++) " << endl;
						output << "\t\t{" << endl;
							output << "\t\t\tres[i] = new " << c_i_name << "(container.getAt(i), metaDiagram);" << endl;
						output << "\t\t}" << endl;
						output << "\t\treturn res;" << endl;
					output << "\t}" << endl;
				}
				else
				{
					output << "\tpublic " << c_i_name << " get" << c_i_name << "Child() throws UdmException "<< endl;
					output << "\t{" << endl;

					if(strcmp(ccr_name.c_str(), "") == 0) {
						output << "\t\tUdmPseudoObjectContainer container = getChildren(null, " << c_i_name << ".META_TYPE);" << endl;
					} else {
						output << "\t\tUdmPseudoObjectContainer container = getChildren(\"" << ccr_name << "\"," << c_i_name << ".META_TYPE);" << endl;
					}

						output << "\t\treturn new " << c_i_name << "(container.getAt(0), metaDiagram);" << endl;
					output << "\t}" << endl;

				}

			}
			else
			{
				//generate a common getter function for these types of children


				output << "\tpublic " << c_i_name << "[] get" << c_i_name << "Children() throws UdmException "<< endl;
				output << "\t{" << endl;
					output << "\t\tUdmPseudoObjectContainer container = getChildren(null," <<  c_i_name << ".META_TYPE);" << endl;
					output << "\t\t" << c_i_name << "[] array = new " << c_i_name << "[container.getLength()];" << endl;
					output << "\t\tfor (int i = 0; i < container.getLength(); i++) " << endl;
					output << "\t\t{" << endl;
						output << "\t\t\tarray[i] = new " << c_i_name << "(container.getAt(i), metaDiagram);" << endl;
					output << "\t\t}" << endl;	
					output << "\t\treturn array;" << endl;
				output << "\t}" << endl;
				//end of common getter function generation

				set<Uml::CompositionChildRole> ccrs = Uml::CompositionPeerChildRoles(cl);
				
				for (set<Uml::CompositionChildRole>::iterator ccrs_i = ccrs.begin(); ccrs_i != ccrs.end(); ccrs_i++)
				{
					Uml::Class parent = Uml::theOther(*ccrs_i).target();
					Uml::Class child = ccrs_i->target();
					string child_name = child.name();
					Uml::Composition comp = Uml::matchChildToParent(child, parent);
					if (!comp)
					{
						//will reach here only if more than one composition is possible

						//string child role name
						string ccr_name = ccrs_i->name();

						output << "\tpublic static final String " << GetCCRString(*ccrs_i) << " = \"" << (string) ccrs_i->name() << "\";" << endl;		
	/*
						//createRoleName
						output << "\tpublic " << child_name << " create" << ccr_name << "() throws UdmException " << endl;
						output << "\t{" << endl;
							output << "\t\t" << child_name << ".initMetaClass(metaDiagram);" << endl;
							output << "\t\treturn new " << child_name <<"(createObject(" << child_name << ".META_TYPE, " << GetCCRString(*ccrs_i) << "), metaDiagram);" << endl;
						output << "\t}" << endl;
	*/
						//getRoleName
						if ((ccrs_i->max() == -1) || (ccrs_i->max() > 1))
						{
							 output << "\tpublic " << child_name << "[] get" << ccr_name << "Children() throws UdmException "<< endl;
							 output << "\t{" << endl;
								output << "\t\tUdmPseudoObjectContainer container = getChildren("<< GetCCRString(*ccrs_i) << "," <<  child_name << ".META_TYPE);" << endl;
								output << "\t\t" << child_name << "[] array = new " << child_name << "[container.getLength()];" << endl;
								output << "\t\tfor (int i = 0; i < container.getLength(); i++) " << endl;
								output << "\t\t{" << endl;
										output << "\t\t\tarray[i] = new " << child_name << "(container.getAt(i), metaDiagram);" << endl;
								output << "\t\t}" << endl;	
								output << "\t\treturn array;" << endl;
							output << "\t}" << endl;
						}
						else
						{
							output << "\tpublic " << child_name << " get" << ccr_name << "Child() throws UdmException "<< endl;
							output << "\t{" << endl;
								output << "\t\tUdmPseudoObjectContainer container = getChildren(" << GetCCRString(*ccrs_i)<< "," << child_name << ".META_TYPE);" << endl;
								output << "\t\treturn new " << child_name << "(container.getAt(0), metaDiagram);" << endl;
							output << "\t}" << endl;
						}

					};
				};
			}
		}

	};
};

void GenerateAttributeAccesors(const Uml::Class &cl, ofstream & output)
{
	set<Uml::Attribute> atts = cl.attributes();
	for (set<Uml::Attribute>::iterator atts_i = atts.begin(); atts_i != atts.end(); atts_i++)
	{
		string att_name = atts_i->name();

		// public static final ....
		output << "\tpublic static final String " << att_name << "= \"" << att_name << "\";" << endl;

		string jtype, upo_call;
		
		bool array = ((atts_i->max() > 1) || (atts_i->max() < 0));

		if (((string)atts_i->type() == "String") || ((string)atts_i->type() == "Text"))
		{
			if (array)
			{
				jtype = "String []";
				upo_call = "StrValues";
			}
			else
			{
				jtype = "String";
				upo_call = "StringVal";
			}
			
		} else if ((string)atts_i->type() == "Real") 
		{
			if (array)
			{
				jtype = "double []";
				upo_call = "RealValues";
			}
			else
			{
			
				jtype = "double";
				upo_call = "RealVal";
			}

		} else if ((string)atts_i->type() == "Boolean") 
		{
			if (array)
			{
				jtype = "boolean []";
				upo_call = "BoolValues";
			}
			else
			{
				jtype = "boolean";
				upo_call = "BooleanVal";
			}
			
		} else
		{
			if (array)
			{
				jtype = "long []";
				upo_call = "IntValues";
			}
			else
			{
				jtype = "long";
				upo_call = "IntVal";
			}
		};


	

		output << "\tpublic void set" << att_name << "(" << jtype << " n) throws UdmException " << endl;
		output << "\t{" << endl;
			output << "\t\tset" << upo_call << "(" << att_name << ", n);" << endl;
		output << "\t}" << endl;

		output << "\tpublic " << jtype << " get" << att_name << "() throws UdmException " << endl;
		output << "\t{" << endl;
			output << "\t\treturn get" << upo_call << "(" << att_name << ");" << endl;
		output << "\t}" << endl;
		

      
		
	};
};

void GenerateJavaAssocClass(const Uml::Class &cl, ofstream & output)
{
	Uml::Association ass = Uml::GetAncestorAssociation(cl);
	if (!ass) return;
	set<Uml::AssociationRole> ass_roles = ass.roles();
	for(set<Uml::AssociationRole>::iterator a_r_i = ass_roles.begin(); a_r_i != ass_roles.end(); a_r_i ++)
	{
		string tname = ((Uml::Class)a_r_i->target()).name();
		string ar_name = a_r_i->name();
		output << "\tpublic void set" << ar_name << "("<< tname << " a) throws UdmException" << endl; 
		output << "\t{" << endl;
			output << "\t\tUdmPseudoObjectContainer container = new UdmPseudoObjectContainer(1);" << endl;
			output << "\t\tcontainer.setAt(0, a);"<< endl;
			output << "\t\tsetAssociation(\"" << ar_name  << "\", container, UdmHelper.TARGET_FROM_CLASS);" << endl;
	    output << "\t}" << endl;

		output << "\tpublic " << tname << " get" << ar_name <<"() throws UdmException" << endl;
	    output << "\t{" << endl;
		    output << "\t\tUdmPseudoObjectContainer container = getAssociation(\"" << ar_name << "\", UdmHelper.TARGET_FROM_CLASS);" << endl;
			output << "\t\treturn new " << tname << "(container.getAt(0) , metaDiagram);"<< endl;
		output << "\t}" << endl;

	};
};


void GenerateJavaAssociations(const Uml::Class &cl, ofstream & output, string diagName)
{
	set<Uml::AssociationRole> assroles = cl.associationRoles();
	if (!assroles.size()) return;
	for (set<Uml::AssociationRole>::iterator ar_i = assroles.begin(); ar_i != assroles.end(); ar_i++)
	{
		string asr_name = ar_i->name();
		string to_asr_name = Uml::theOther(*ar_i).name();
		string ass_class_name;
		string tname = ((Uml::Class)((Uml::theOther(*ar_i)).target())).name();
		string helper_mode = "TARGET_FROM_PEER";

		Uml::Association ass = ar_i->parent();		
		Uml::Class ass_class = ass.assocClass();
		if (ass_class) 
		{
			ass_class_name = ass_class.name();
			tname = ass_class_name;
			helper_mode = "CLASS_FROM_TARGET";
		};

		output << "\tpublic static final String " << to_asr_name << "_AR = \"" << to_asr_name << "\";" << endl;

		if ((ar_i->max() == 0) || (ar_i->max() ==1))
		{
			//single cardinality

			output << "\tpublic void set" << to_asr_name << "(" << tname << " a) throws UdmException" << endl; 
			output << "\t{" << endl;
				output << "\t\tsetAssociation(" << to_asr_name  << "_AR, a, UdmHelper." << helper_mode << ");" << endl;
			output << "\t}" << endl;

			output << "\tpublic " << tname << " get" << to_asr_name << "() throws UdmException" << endl; 
			output << "\t{" << endl;
				output << "\t\tUdmPseudoObject result = getSingleAssociatedObject(" << to_asr_name << "_AR, UdmHelper." << helper_mode<< ");" << endl;
				output << "\t\treturn (result == null) ? null : new " << tname << "(result, getDiagram());" << endl;
			output << "\t}" << endl;
		}
		else
		{
			output << "\tpublic void set" << to_asr_name << "(" << tname << "[] a) throws UdmException" << endl; 
			output << "\t{" << endl;
				output << "\t\tsetAssociation(" << to_asr_name  << "_AR, new UdmPseudoObjectContainer(a), UdmHelper." << helper_mode << ");" << endl;
			output << "\t}" << endl;

			output << "\tpublic " << tname << "[] get" << to_asr_name << "() throws UdmException" << endl; 
			output << "\t{" << endl;
				output << "\t\tUdmPseudoObjectContainer objs = getAssociation(" << to_asr_name << "_AR, UdmHelper."<< helper_mode << ");" << endl;
		        output << "\t\treturn (" << tname << "[]) " << diagName << "Factory.wrapWithSubclass(objs, " << tname << ".class, getDiagram());" << endl;
			output << "\t}" << endl;
		}
	};

};
void GenerateJavaClass(const Uml::Class &cl, string diagName)
{
	string cl_name = cl.name();
	ofstream output;

	output.open( (cl_name + ".java").c_str());
	if(!output.good()) throw udm_exception("Error opening for write " + cl_name + ".java");

	output << "/* generated on " << GetTime() << " */" << endl;
	output << "package edu.vanderbilt.isis." << tolower((string)Uml::Diagram(cl.parent()).name()) << ";" << endl;
	output << "import edu.vanderbilt.isis.udm.*;" << endl;

	set<Uml::Class> bases = cl.baseTypes();
	string  base_name;
	if (bases.size() > 1) throw udm_exception(string("Java does not support multiple inheritence. Class:") + cl_name);
	if (bases.size())
		base_name = bases.begin()->name();
	else
		base_name = "UdmPseudoObject";

	if (cl.isAbstract())
		output << "public abstract class " << cl_name << " extends " << base_name << endl;
	else
		output << "public class " << cl_name << " extends " << base_name << endl;

	output << "{" << endl << endl;

	if (cl.isAbstract() == false)
	{
		output << "\tpublic static final String META_TYPE = \"" << cl_name << "\";" << endl;
		output << "\tprivate static UdmPseudoObject metaClass;" << endl;
	}

	if (cl.isAbstract())
		output << "\tprotected " << cl_name << "(UdmPseudoObject upo, Diagram metaDiagram) throws UdmException" << endl;
	else
		output << "\t" << cl_name << "(UdmPseudoObject upo, Diagram metaDiagram) throws UdmException" << endl;
	output << "\t{" << endl;
/*
		output << "\t\tif(metaClass == null) " << endl;
		output << "\t\t{" << endl;
			output <<  "\t\t\tthrow new IllegalStateException(\"Meta class not set.\");" << endl;
		output <<  "\t\t}" << endl;
		output <<  "\t\tsetDiagram(metaDiagram);" << endl;
		output <<  "\t\tsetUPO(upo);" << endl;
*/
		output <<  "\t\tsuper(upo, metaDiagram);" << endl;
    output << "\t}" << endl <<endl;
    
	if (cl.isAbstract() == false)
	{
		/*
	
		output << "\tstatic void initMetaClass(Diagram diagram) throws UdmException "<< endl;
		output << "\t{" << endl;
			output << "\t\tif(metaClass == null)" << endl;
			output << "\t\t{" << endl;
				output << "\t\t\tmetaClass = initClassMetaInfo(diagram, META_TYPE);" << endl;
		     output << "\t\t}" << endl;
		output << "\t}" << endl <<endl;

		*/

		output << "\tUdmPseudoObject getMetaClass()" << endl;
		output << "\t{" << endl;
		output << "\t\treturn metaClass;" << endl;
		output << "\t}" << endl;
	}

	//factory
	GenerateJavaClassFactory(cl, output);
	//containments ( createChild + getXXXChildren)
	GenerateJavaClassContainments(cl, output);

	//attributes
	GenerateAttributeAccesors(cl, output);

	//associations

	GenerateJavaAssociations(cl, output, diagName);
	//assoc class.
	GenerateJavaAssocClass(cl, output);
	//end of class
	output << "}" << endl;

	output.close();
	output.clear();
};

vector<Uml::Class> getPossibleRootClasses(const Uml::Diagram & diagram)
{
	vector<Uml::Class> globalElements;
	set<Uml::Class> classes = diagram.classes();
	set<Uml::Class>::iterator i = classes.begin();
	while( i != classes.end() )
	{
		if(!(bool)i->isAbstract() )
		{
			set<Uml::Class> p_c = Uml::AncestorContainerClasses(*i);		//all possible containers
			
			//the condition: It's not contained or it's only container is itself
			if ( (p_c.size() == 0) || ( (p_c.size() == 1) && ( *(p_c.begin()) == *i )) )
			//if  (Uml::AncestorContainerClasses(*i).size() < 1 ) //it's not self contained
				globalElements.push_back(*i);

		}
		++i;
	}
	return globalElements;
};

void GenerateFactory(const Uml::Diagram &diagram)
{
	string name = diagram.name();
	ofstream output;

	output.open( (name + "Factory.java").c_str());
	if(!output.good()) throw udm_exception("Error opening for write " + name + "Factory.java");
	
	
	output << "/* generated on " << GetTime() << " */" << endl;
	output << "package edu.vanderbilt.isis." << tolower(name)<< ";" << endl;
	output << "import edu.vanderbilt.isis.udm.*;" << endl;
	output << "import java.lang.reflect.Array;" << endl;

//

	output << "public class " << name << "Factory extends UdmFactory" << endl;
	output << "{" << endl;
		output << "\tprivate static final String packagePath = \"/edu/vanderbilt/isis/" << tolower(name) << "/\";" << endl;
		output << "\tprivate static final String xmlMetaFile =\"" << name << ".xml\";" << endl;
		output << "\tprivate static final String xsdMetaFile =\"" << name << ".xsd\";" << endl;
		output << "\tprivate static final String metaName =\"" << name << "\";" << endl;
	

	output << "\tpublic " << name << "Factory() throws UdmException " << endl;
	output << "\t{" << endl;
		output << "\t\tsuper(xmlMetaFile, xsdMetaFile, metaName, packagePath);" << endl;
		output << "\t\tinitializeMetaClasses();" << endl;
	output << "\t}" << endl;
    
	set<Uml::Class>::iterator classes_i;

	output << "\tprivate void initializeMetaClasses() throws UdmException " << endl;
	output << "\t{" << endl;
		set<Uml::Class> classes = diagram.classes();
		for(classes_i = classes.begin(); classes_i != classes.end(); classes_i++)
		{	Uml::Class cl = *classes_i;

			if (cl.isAbstract() == false)
				output << "\t\tmetaDiagram.getMetaClass(" << cl.name() << ".META_TYPE);" << endl;
				//output << "\t\t" << cl.name() << ".initMetaClass(metaDiagram);" << endl;
		}
	output << "\t}" << endl;

    
	vector<Uml::Class> roots = getPossibleRootClasses(diagram);
	vector<Uml::Class>::iterator r_i;
	for ( r_i = roots.begin(); r_i != roots.end(); r_i++)
	{
		string rc_name = r_i->name();

		output << "\tpublic " << rc_name << " createNewDataNetwork" << rc_name<< "(String instanceFileName) throws UdmException" << endl; 
		output << "\t{" << endl;
			output << "\t\treturn new " << rc_name << "(createNewDN(instanceFileName, metaDiagram.getMetaClass("<< rc_name << ".META_TYPE)), metaDiagram);" << endl;
		output << "\t}" << endl;

	}

	output << "\tpublic UdmPseudoObject openExistingDataNetwork(String instanceFileName) throws UdmException" << endl; 
	output << "\t{" << endl;

		output << "\t\tUdmPseudoObject root = openExistingDN(instanceFileName);" << endl;

	for ( r_i = roots.begin(); r_i != roots.end(); r_i++)
	{
		string rc_name = r_i->name();

		output << "\t\tif(" << rc_name << ".META_TYPE.equals(root.getType()))" << endl;
		output << "\t\t{" << endl;
		output << "\t\t\treturn new " << rc_name << "(root, metaDiagram);" << endl;
		output << "\t\t}" << endl;
		output << "\t\telse" << endl;
	}
		output << "\t\t{" << endl;
			output << "\t\t\tthrow new UdmException(\"Root object has unexpected type: \" + root.getType(), true);" << endl;
		output << "\t\t}" << endl;
	output << "\t}" << endl;



	output << "\tpublic static UdmPseudoObject wrapWithSubclass(UdmPseudoObject obj, Diagram diagram) throws UdmException" << endl;
	output << "\t{" << endl;

		output << "\t\tString type = obj.getType();" << endl;

	
	
	for (classes_i = classes.begin(); classes_i != classes.end(); classes_i++)
	{
		string c_name = classes_i->name();

		if (classes_i->isAbstract()) continue;
		output << "\t\tif(" << c_name << ".META_TYPE.equals(type))" << endl;
		output << "\t\t{" << endl;
		output << "\t\t\treturn new " << c_name << "(obj, diagram);" << endl;
		output << "\t\t}" << endl;
		output << "\t\telse" << endl;
	}
		output << "\t\t{" << endl;
			output << "\t\t\tthrow new UdmException(\"Unexpected type: \'\" + type + \"\'\", true);" << endl;
		output << "\t\t}" << endl;
	output << "\t}" << endl;

	

//dummmy static generation
	output << "\tpublic static UdmPseudoObject[] wrapWithSubclass(UdmPseudoObjectContainer objs, Class arrayClass, Diagram diagram) throws UdmException " << endl;
	output << "\t{" << endl;
        output << "\t\tif (!UdmPseudoObject.class.isAssignableFrom(arrayClass)) "<< endl;
		output << "\t\t{" << endl;
			output << "\t\t\tthrow new IllegalArgumentException(\"\" + arrayClass + \" is not a subtype of \"+ UdmPseudoObject.class.getName());" << endl;
		output << "\t\t}" << endl;
        output << "\t\tUdmPseudoObject[] res = (UdmPseudoObject[]) Array.newInstance(arrayClass, objs.getLength());" << endl;
        output << "\t\tfor (int i = 0; i < res.length; i++) " << endl;
		output << "\t\t{" << endl;
            output << "\t\t\tUdmPseudoObject obj = objs.getAt(i);" << endl;
            output << "\t\t\tif (obj != null) " << endl;
			output << "\t\t\t{" << endl;
				output << "\t\t\t\tres[i] = wrapWithSubclass(obj, diagram);" << endl;
            output << "\t\t\t}" << endl;                
        output << "\t\t}" << endl;
        output << "return res;" << endl;
	output << "\t}" << endl;


	output << "}" << endl;

//
	output.close();
	output.clear();
};

void GenerateJava(const Uml::Diagram &diagram)
{
	GenerateFactory(diagram);
	string diagName = diagram.name();
	set<Uml::Class> uml_classes = diagram.classes();
	for (set<Uml::Class>::iterator uc_i = uml_classes.begin(); uc_i != uml_classes.end(); uc_i++)
	{
		GenerateJavaClass(*uc_i, diagName);
	}
};

